﻿using Syncfusion.Olap.Manager;
using Syncfusion.Olap.Reports;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Web.Http;
using System.Web.Script.Serialization;
using Syncfusion.JavaScript.Olap;
using System.Web;
using OLAPUTILS = Syncfusion.JavaScript.Olap;
using System.Data;
using System.Text;

namespace PivotGridDemo
{
    public class OlapGridController : ApiController
    {
        Syncfusion.JavaScript.PivotGrid htmlHelper = new Syncfusion.JavaScript.PivotGrid();
        string connectionString = "Data Source=GMOORE-E6530\\SQL2012_LOCAL;Initial Catalog=Cubes;Integrated Security=SSPI;";
        JavaScriptSerializer serializer = new JavaScriptSerializer();

        [System.Web.Http.ActionName("InitializeGrid")]
        [System.Web.Http.HttpPost]
        public Dictionary<string, object> InitializeGrid(Dictionary<string, object> jsonResult)
        {
            OlapDataManager DataManager = null;
            DataManager = new OlapDataManager(connectionString);
            //DataManager.MdxQuery = "WITH  MEMBER [Measures].[Order on Discount Sale] As  [Measures].[Order Quantity] + ([Measures].[Order Quantity] * 0.10)  MEMBER [Customer].[Customer].[CalcMember] As  [Customer].[Customer Geography]  SELECT   NONEMPTY( VISUALTOTALS( ({{Drilldownlevel({ [Customer].[Customer Geography] })}}) ) * {[Measures].[Internet Sales Amount], [Measures].[Sales Amount]} * {[Customer].[Customer].[CalcMember]}, VISUALTOTALS( ({{Drilldownlevel({ [Date].[Fiscal] })}}) ))  dimension properties MEMBER_TYPE, PARENT_UNIQUE_NAME  ON COLUMNS ,  NONEMPTY( VISUALTOTALS( ({{Drilldownlevel({ [Date].[Fiscal] })}}) ), VISUALTOTALS( ({{Drilldownlevel({ [Customer].[Customer Geography] })}}) ) * {[Measures].[Internet Sales Amount], [Measures].[Sales Amount]} * {[Customer].[Customer].[CalcMember]})  dimension properties MEMBER_TYPE, PARENT_UNIQUE_NAME  ON ROWS  FROM [Adventure Works]  CELL PROPERTIES VALUE, FORMAT_STRING, FORMATTED_VALUE";
            DataManager.SetCurrentReport(CreateOlapReport());
            DataManager.OverrideDefaultFormatStrings = true;
            return htmlHelper.GetJsonData(jsonResult["action"].ToString(), DataManager, jsonResult.ContainsKey("gridLayout") ? jsonResult["gridLayout"].ToString() : null, Convert.ToBoolean(jsonResult["enablePivotFieldList"].ToString()));
            
        }

        [System.Web.Http.ActionName("DrillGrid")]
        [System.Web.Http.HttpPost]
        public Dictionary<string, object> DrillGrid(Dictionary<string, object> jsonResult)
        {
            OlapDataManager DataManager = new OlapDataManager(connectionString);
            DataManager = new OlapDataManager(connectionString);
            DataManager.SetCurrentReport(Utils.DeserializeOlapReport(jsonResult["currentReport"].ToString()));
            return htmlHelper.GetJsonData(jsonResult["action"].ToString(), connectionString, DataManager, jsonResult["cellPosition"].ToString(), jsonResult["headerInfo"].ToString(), jsonResult["layout"].ToString());
        }

        [System.Web.Http.ActionName("Paging")]
        [System.Web.Http.HttpPost]
        public Dictionary<string, object> Paging(Dictionary<string, object> jsonResult)
        {
            OlapDataManager DataManager = new OlapDataManager(connectionString);
            DataManager.SetCurrentReport(htmlHelper.SetPaging(jsonResult["currentReport"].ToString(), jsonResult["pagingInfo"].ToString()));
            return htmlHelper.GetJsonData(jsonResult["action"].ToString(), DataManager, jsonResult["layout"].ToString());
        }

        private OlapReport CreateOlapReport()
        {
            OlapReport olapReport = new OlapReport();
            olapReport.CurrentCubeName = "Sales";

                //DimensionElement internalDimension = new DimensionElement();
                //internalDimension.Name = "Product";
                //internalDimension.AddLevel("Product Categories", "Category");

                //// Calculated Measure
                CalculatedMember calculatedMeasure1 = new CalculatedMember();
                calculatedMeasure1.Name = "Quantity - Prior Year";
                calculatedMeasure1.Expression = 
                "(PARALLELPERIOD([Transaction Date].[Calendar Hierarchy-Month].[Fiscal Year], 1,[Transaction Date].[Calendar Hierarchy-Month].CurrentMember),[Measures].[Quantity])";

            calculatedMeasure1.AddElement(new MeasureElement { Name = "Quantity" });

                //CalculatedMember calculatedMeasure2 = new CalculatedMember();
                //calculatedMeasure2.Name = "Order Quantity Difference";
                //calculatedMeasure2.Expression = "([Measures].[Order Quantity Discount]-[Measures].[Order Quantity]) - 500.50";
                //calculatedMeasure2.AddElement(new MeasureElement { Name = "Order on Discount" });
                //calculatedMeasure2.AddElement(new MeasureElement { Name = "Order Quantity" });

                //CalculatedMember calculatedMeasure3 = new CalculatedMember();
                //calculatedMeasure3.Name = "Order Quantity % Change";
                //calculatedMeasure3.Expression = "([Measures].[Order Quantity Difference] / 100)";
                //calculatedMeasure3.AddElement(new MeasureElement { Name = "Order on Discount Difference" });

                // Calculated Dimension
                //CalculatedMember calculateDimension = new CalculatedMember();
                //calculateDimension.Name = "Bikes & Components";
                //calculateDimension.Expression = "([Product].[Product Categories].[Category].[Bikes] + [Product].[Product Categories].[Category].[Components] )";
                //calculateDimension.AddElement(internalDimension);

                MeasureElements measureElementColumn = new MeasureElements();
                //measureElementColumn.Elements.Add(new MeasureElement { Name = "Sales Amount" });
                measureElementColumn.Elements.Add(new MeasureElement { Name = "Quantity" });

                DimensionElement dimensionElementRow = new DimensionElement();
                //Specifying the Dimension Name
                dimensionElementRow.Name = "Transaction Date";
                dimensionElementRow.AddLevel("Calendar Hierarchy-Month", "Fiscal Year");


                //// Adding Calculated members in calculated member collection
                olapReport.CalculatedMembers.Add(calculatedMeasure1);
                //olapReport.CalculatedMembers.Add(calculatedMeasure2);
                //olapReport.CalculatedMembers.Add(calculatedMeasure3);
                //olapReport.CalculatedMembers.Add(calculateDimension);

                ///Adding Measure Element
                //olapReport.CategoricalElements.Add(measureElementColumn);
                //olapReport.CategoricalElements.Add(calculatedMeasure1);
                olapReport.CategoricalElements.Add(dimensionElementRow);

                olapReport.SeriesElements.Add(measureElementColumn);
                olapReport.SeriesElements.Add(calculatedMeasure1);
                //olapReport.SeriesElements.Add(calculatedMeasure2);
                //olapReport.SeriesElements.Add(calculatedMeasure3);
                ///Adding Row Members
                //olapReport.SeriesElements.Add(dimensionElementRow);
                //olapReport.SeriesElements.Add(calculateDimension);

            return olapReport;
        }
    }
}